import Globals
import six

from . import virtualgpio as GPIO
import datetime

from rpcmethods import *
import broker

@six.add_metaclass(DevMeta)
class Alarm:

  #__devname__  = 'alarms'

  def __init__(self, name, pin):
    self.name = name
    self.circuit = parse_name(name)
    self.pin = pin

  def check(self):
    if self.pin:
      device = check_dev_type(self.pin, GPIO.gpin, 'Alarm %s'%self.name, 'pin')
      self.pin = device
      if device:
        device.add_event_detect(GPIO.BOTH, callback=self.alarmEvent)
        Globals.logger.debug("Alarm %s initialized",self.name)

  def sendUpdate(self):
    broker.callobj('alarmEvent',self, self.pin.value)
    return "OK"

  def getState(self):
    return self.pin.value

  async def alarmEvent(self, gpin):
    self.sendUpdate()
    if (self.pin.value):
      Globals.logger.debug("Movement on alarm %s ", self.name)
    else:
      Globals.logger.debug("Movement off alarm %s ", self.name)

Foptions = {
    'pin': {'type': 'node', 'help': 'Link to some input' }
}

def YFactory(Node, devname, parent=None):
    kwargs = get_kwargs(Foptions, Node)
    return Alarm(devname, **kwargs)
