import Globals
import time
import datetime
import sys
import six

import json, re
from rpcmethods import *
from .reader import NfcReader
from device import virtualgpio as GPIO

@six.add_metaclass(DevMeta)
class NfcLed(GPIO.gpout):

    def __init__(self, name, channel, pin):
        if not (pin in (2,3)): raise Exception("pin must be 2 or 3 (blue or red led)")
        self.name = name
        self.circuit = parse_name(name)
        self.reader = channel
        self.pin = pin
        self.value = None

    def check(self):
        device = check_dev_type(self.reader, NfcReader, 'Led %s'%self.name, 'channel')
        self.reader = device

    async def output(self, value):
        await self.reader.sendLed(self.pin)

    async def set_for_time(self, value, timeout):
        await self.reader.sendLed(self.pin)

    def add_callback(self, callback):
        return


Foptions = {
    'channel': {'type': 'node', 'help': 'Link to Netronix bus' },
    'pin':     {'type': int, 'help': 'Bus identification of led (2 or 3)' },
}


def YFactory(Node, devname, parent = None):
    kwargs = get_kwargs(Foptions, Node, parent)
    return NfcLed(devname, **kwargs)


#    setattr(RPCMethods,'blueLed', blueLed)
