import Globals
import os
import sys
import six
from future.utils import iteritems

import asyncio
from aiohttp import web
#, ClientSession, WSMsgType
from jsonrpcserver import async_dispatch as dispatch
from jsonrpcserver.methods import Methods

from . import register_post_handler

#
# JSON RPC Server part
#
from rpcmethods import *


'''
@six.add_metaclass(DevMeta)
class JsonRpc(SimpleJSONRPCServer, object):

    def __init__(self, name, rpi_id, rpc_port):
        SimpleJSONRPCServer.__init__(self,('',rpc_port), bind_and_activate=False)
        self.name = name
        self.rpi_id = rpi_id
        self.rpc_port = rpc_port
        self.rpcmethods = None

    #prepare to start RPC server
    def start(self):
        #Globals.local_port = rpc_port
        Globals.logger.info('Starting RPC JSON server on port %i', self.rpc_port)
        self.rpcmethods = RPCMethods(self.name)
        self.register_instance(self.rpcmethods)
        self.server_bind()
        self.server_activate()
        #x = getattr(rpcmethods,'sayHi')
        #if x: print(x())
'''

@six.add_metaclass(DevMeta)
class RpcView:

    def __init__(self, name, rpi_id, path):
        #self.methods = None
        self.name = name
        self.path = path
        self.rpi_id = rpi_id
        self.methods = Methods()

    def start(self):
        Globals.logger.info('Starting RPC JSON server %s on path %s', self.name, self.path)
        for k,v in iteritems(RPCMethods.__dict__):
            if not(k.startswith('__')):
                self.methods.add(name=k)(v)

        self.methods.add(name='sayHi')(self.sayHi)
        # register self to web app
        register_post_handler(self.post, self.path)


    async def sayHi(self):
        return "Hi, my name is "+str(self.rpi_id)


    async def post(self, request):
        request = await request.text()
        #print(request)
        response = await dispatch(request, methods = self.methods) ## 
        #print(response)
        if response.wanted:
            return web.json_response(response.deserialized(), status=response.http_status)
        else:
            return web.Response()
        #return await post_resp(self.request)


Foptions = {
    'rpi_id': {'type': str, 'help': 'Controller id' },
    'path':   {'type': str, 'help': 'Path in server uri. Default /rpc', 'default' : '/rpc'},
#    'rpc_port': {'type': int, 'help': 'Listening tcp port. Default 8080' },
}

def YFactory(Node, devname, parent = None):
    kwargs = get_kwargs(Foptions, Node)
    obj = RpcView(devname, **kwargs)
    return obj
